﻿--[[
        Give Me Health:
                Copyright 2009 by MERK, Mileg
                based on code by Mileg and Stephen Blaising
                
]]

GMHealth_ADDONNAME = "Give Me Health";
GMHealth_MACRONAME = "GMHealth";

GMHealth_VERSION = "4.2.0";

COOKIN = "";
COOKIN2 = "";
NoCOOKIN = 1;
CONJFOOD = "";
CharHP = 0;
DP = 0;
TP = 0;
QP = 0;
SP = 0;
GMHealth_ZoneName = "Default";
GMHealth_ZoneType = "Default";

function GMHealth_OnLoad()
  this:RegisterEvent("PLAYER_LOGIN");
  this:RegisterEvent("BAG_UPDATE");

  SlashCmdList["GIVEMEHEALTHCOMMAND"] = GMHealth_SlashHandler;
  SLASH_GIVEMEHEALTHCOMMAND1 = "/givemehealth";
  SLASH_GIVEMEHEALTHCOMMAND2 = "/gmhealth";
  SLASH_GIVEMEHEALTHCOMMAND3 = "/gmh";
  
end

function GMHealth_OnEvent()
  if (event == "PLAYER_LOGIN") then
    if (GetMacroIndexByName(GMHealth_MACRONAME) == 0) then
      local numGenMacros, numCharMacros = GetNumMacros();
      if (numGenMacros < 36) then
        CreateMacro(GMHealth_MACRONAME, 7, "", nil, nil)
      else
        GMHealth_Print("You have 36 General Macros. Cannot add "..GMHealth_MACRONAME.."!");
      end
    end
    if (GetSpellInfo(COOK)) then
      COOKIN = "[mod:ctrl,nocombat] "..COOK..";";
      COOKIN2 = "[] "..COOK..";";
    else
      COOKIN = "";
      NoCOOKIN = 7;
    end
    if (GetSpellInfo(CONJR)) then
      CONJFOOD = "[button:2] "..CONJR..";";
    elseif (GetSpellInfo(CONJF)) then
      CONJFOOD = "[button:2] "..CONJF..";";
    else
      CONJFOOD = "";
    end
    GMHealth_MakeArray();
    GMHealth_Go();
  elseif (event == "BAG_UPDATE") then
    CharHP = UnitHealthMax("player");
    DP = CharHP * .02;
    TP = CharHP * .03;
    QP = CharHP * .04;
    SP = CharHP * .05;
    GMHealth_MakeArray();
    GMHealth_Go();
  end
end

function GMHealth_OnUpdate()
  if (GMHealth_ZoneName ~= GetRealZoneText()) then
    GMHealth_Go();
  end
end

function GMHealth_SlashHandler(msg)
  if (msg) then
    msg = string.lower(msg);
  end
  if (msg == "help" or msg == "") then
    GMHealth_Print(GMHealth_ADDONNAME.." |cff3399CCv"..GMHealth_VERSION.." ");
    GMHealth_Print("Type /macro to open macro list.");
    GMHealth_Print("Drag GMHealth macro to your action bar.");
    GMHealth_Print("This macro has two purposes.");
    GMHealth_Print("During combat click to use best healing potion.");
    GMHealth_Print("Otherwise click to eat best food.");
    GMHealth_Print("Hold SHIFT and click to use/eat second best healing potion/food.");
    GMHealth_Print("Hold ALT and click to use best healing potion out of combat.");
    GMHealth_Print("Hold SHIFT+ALT and click to use second best healing potion out of combat.");
    GMHealth_Print("Hold CTRL and click to open \"Cooking\" tradeskill window.");
    GMHealth_Print("Mages can right click to \"Conjure Food\".");
  end
end

function GMHealth_GetZoneType()
  if (GMHealth_ZoneName ~= GetRealZoneText()) then
    GMHealth_ZoneName = GetRealZoneText();
    if ((GMHealth_ZoneName == WSG) or (GMHealth_ZoneName == AV) or (GMHealth_ZoneName == AB) or (GMHealth_ZoneName == EOTS) or (GMHealth_ZoneName == SOTA)) then
      GMHealth_ZoneType = "BG";
    elseif ((GMHealth_ZoneName == BOT) or (GMHealth_ZoneName == EYE) or (GMHealth_ZoneName == MECH) or (GMHealth_ZoneName == ARCA)) then
      GMHealth_ZoneType = "TK";
    elseif ((GMHealth_ZoneName == SSC) or (GMHealth_ZoneName == UB) or (GMHealth_ZoneName == SV) or (GMHealth_ZoneName == SP)) then
      GMHealth_ZoneType = "CFR";
    elseif ((GMHealth_ZoneName == BEM) or (GMHealth_ZoneName == GL)) then
      GMHealth_ZoneType = "BE";
    elseif ((GMHealth_ZoneName == ARENA_BE) or (GMHealth_ZoneName == ARENA_D) or (GMHealth_ZoneName == ARENA_N) or (GMHealth_ZoneName == ARENA_ROL) or (GMHealth_ZoneName == ARENA_ROV)) then
      GMHealth_ZoneType = "ARENA";
    else
      GMHealth_ZoneType = "ALL";
    end
  end
end

function GMHealth_Print(msg)
  if ((msg) and (strlen(msg) > 0)) then
    if (DEFAULT_CHAT_FRAME) then
      DEFAULT_CHAT_FRAME:AddMessage(msg, 1, 1, 0);
    end
  end
end

function GMHealth_MakeArray()
  GMHealth_Potions = {
    [38] = { [1] = HEAL_ARENA_2160, [2] =  0, [3] = 2160, [4] = "ARENA", [5] = "ALL" },
    [37] = { [1] = HEAL_TK_2500,    [2] = 55, [3] = 2500, [4] = "TK",    [5] = "ALL" },
    [36] = { [1] = HEAL_BEP_1750_2, [2] = 70, [3] = 1750, [4] = "BE",    [5] = "ALL" },
    [35] = { [1] = HEAL_BEP_1750,   [2] = 70, [3] = 1750, [4] = "BE",    [5] = "ALL" },
    [34] = { [1] = HEAL_CFR_2500,   [2] = 55, [3] = 2500, [4] = "CFR",   [5] = "ALL" },
    [33] = { [1] = HEAL_1260_P,     [2] = 45, [3] = 1260, [4] = "BG",    [5] = "ALL" }, 
    [32] = { [1] = HEAL_720_P,      [2] = 35, [3] =  720, [4] = "BG",    [5] = "ALL" },
    [31] = { [1] = HEAL_4500_I,     [2] = 70, [3] = 4501, [4] = "ALL",   [5] = "ALL" },
    [30] = { [1] = HEAL_4500,       [2] = 70, [3] = 4500, [4] = "ALL",   [5] = "ALL" },
    [29] = { [1] = RJ_4125,         [2] = 75, [3] = 4125, [4] = "ALL",   [5] = "ALL" },
    [28] = { [1] = CA_3500h_4500m,  [2] = 70, [3] = 3500, [4] = "ALL",   [5] = "ALL" },
    [27] = { [1] = RJ_2750,         [2] = 65, [3] = 2751, [4] = "ALL",   [5] = "ALL" },
    [26] = { [1] = MA_2750,         [2] = 60, [3] = 2750, [4] = "ALL",   [5] = "ALL" },
    [25] = { [1] = HEAL_2500_I2,    [2] = 55, [3] = 2501, [4] = "ALL",   [5] = "ALL" },
    [24] = { [1] = HEAL_2500_I,     [2] = 55, [3] = 2501, [4] = "ALL",   [5] = "ALL" },
    [23] = { [1] = HEAL_2500_5,     [2] = 55, [3] = 2500, [4] = "ALL",   [5] = "ALL" },
    [22] = { [1] = HEAL_2500_4,     [2] = 55, [3] = 2500, [4] = "ALL",   [5] = "ALL" },
    [21] = { [1] = HEAL_2500_3,     [2] = 55, [3] = 2500, [4] = "ALL",   [5] = "ALL" },
    [20] = { [1] = HEAL_2500_2,     [2] = 55, [3] = 2500, [4] = "ALL",   [5] = "ALL" },
    [19] = { [1] = HEAL_2500,       [2] = 55, [3] = 2500, [4] = "ALL",   [5] = "ALL" },
    [18] = { [1] = HEAL_ARENA_2160, [2] =  0, [3] = 2160, [4] = "ALL",   [5] = "ALL" },
    [17] = { [1] = RJ_1760,         [2] = 50, [3] = 1760, [4] = "ALL",   [5] = "ALL" },
    [16] = { [1] = HEAL_1750_P4,    [2] = 61, [3] = 1750, [4] = "ALL",   [5] = "ALL" },
    [15] = { [1] = HEAL_1750_P3,    [2] = 61, [3] = 1750, [4] = "ALL",   [5] = "ALL" },
    [14] = { [1] = HEAL_1750_P2,    [2] = 61, [3] = 1750, [4] = "ALL",   [5] = "ALL" },
    [13] = { [1] = HEAL_1750_P,     [2] = 61, [3] = 1750, [4] = "ALL",   [5] = "ALL" },
    [12] = { [1] = HEAL_1750_2,     [2] = 55, [3] = 1750, [4] = "ALL",   [5] = "ALL" },
    [11] = { [1] = HEAL_1750,       [2] = 45, [3] = 1750, [4] = "ALL",   [5] = "ALL" }, 
    [10] = { [1] = RJ_1500,         [2] = 35, [3] = 1500, [4] = "ALL",   [5] = "ALL" }, 
    [ 9] = { [1] = HEAL_900_P,      [2] = 35, [3] =  900, [4] = "ALL",   [5] = "ALL" }, 
    [ 8] = { [1] = HEAL_900_2,      [2] = 45, [3] =  900, [4] = "ALL",   [5] = "ALL" }, 
    [ 7] = { [1] = HEAL_900,        [2] = 35, [3] =  900, [4] = "ALL",   [5] = "ALL" }, 
    [ 6] = { [1] = HEAL_585,        [2] = 21, [3] =  585, [4] = "ALL",   [5] = "ALL" },
    [ 5] = { [1] = HEAL_360,        [2] = 12, [3] =  360, [4] = "ALL",   [5] = "ALL" }, 
    [ 4] = { [1] = HEAL_180_2,      [2] =  5, [3] =  180, [4] = "ALL",   [5] = "ALL" },
    [ 3] = { [1] = HEAL_180,        [2] =  3, [3] =  180, [4] = "ALL",   [5] = "ALL" },
    [ 2] = { [1] = RJ_150,          [2] =  5, [3] =  150, [4] = "ALL",   [5] = "ALL" },
    [ 1] = { [1] = HEAL_90,         [2] =  0, [3] =   90, [4] = "ALL",   [5] = "ALL" },
  }

  GMHealth_Food = {
    [214] = { [1] = VEND_BIS_2148_4410_WSG, [2] = 45, [3] =  72, [4] = WSG,   [5] = "ALL" },
    [213] = { [1] = VEND_BIS_1608_3306_WSG, [2] = 35, [3] =  54, [4] = WSG,   [5] = "ALL" },
    [212] = { [1] = VEND_BIS_1074_2202_WSG, [2] = 25, [3] =  36, [4] = WSG,   [5] = "ALL" },
    [211] = { [1] = VEND_BIS_2148_4410_AB3, [2] = 45, [3] =  72, [4] = AB,    [5] = "ALL" },
    [210] = { [1] = VEND_BIS_2148_4410_AB2, [2] = 45, [3] =  72, [4] = AB,    [5] = "ALL" },
    [209] = { [1] = VEND_BIS_2148_4410_AB,  [2] = 45, [3] =  72, [4] = AB,    [5] = "ALL" },
    [208] = { [1] = VEND_BIS_1608_3306_AB3, [2] = 35, [3] =  54, [4] = AB,    [5] = "ALL" },
    [207] = { [1] = VEND_BIS_1608_3306_AB2, [2] = 35, [3] =  54, [4] = AB,    [5] = "ALL" },
    [206] = { [1] = VEND_BIS_1608_3306_AB,  [2] = 35, [3] =  54, [4] = AB,    [5] = "ALL" },
    [205] = { [1] = VEND_BIS_1074_2202_AB3, [2] = 25, [3] =  36, [4] = AB,    [5] = "ALL" },
    [204] = { [1] = VEND_BIS_1074_2202_AB2, [2] = 25, [3] =  36, [4] = AB,    [5] = "ALL" },
    [203] = { [1] = VEND_BIS_1074_2202_AB,  [2] = 25, [3] =  36, [4] = AB,    [5] = "ALL" },
    [202] = { [1] = CONJ_BIS_15000_12960,   [2] = 80, [3] = 501, [4] = "ALL", [5] = "ALL" },
    [201] = { [1] = CONJ_FOOD_15000_3,      [2] = 75, [3] = 501, [4] = "ALL", [5] = "ALL" },
    [200] = { [1] = CONJ_FOOD_15000_2,      [2] = 75, [3] = 501, [4] = "ALL", [5] = "ALL" },
    [199] = { [1] = CONJ_FOOD_15000,        [2] = 75, [3] = 501, [4] = "ALL", [5] = "ALL" },
    [198] = { [1] = CONJ_BIS_13200_9180,    [2] = 74, [3] = 441, [4] = "ALL", [5] = "ALL" },
    [197] = { [1] = CONJ_FOOD_13200,        [2] = 65, [3] = 441, [4] = "ALL", [5] = "ALL" },
    [196] = { [1] = CONJ_BIS_7500_7200,     [2] = 65, [3] = 251, [4] = "ALL", [5] = "ALL" },
    [195] = { [1] = CONJ_FOOD_7500,         [2] = 65, [3] = 251, [4] = "ALL", [5] = "ALL" },
    [194] = { [1] = CONJ_FOOD_4320,         [2] = 55, [3] = 145, [4] = "ALL", [5] = "ALL" },
    [193] = { [1] = CONJ_FOOD_2148,         [2] = 45, [3] =  73, [4] = "ALL", [5] = "ALL" },
    [192] = { [1] = CONJ_FOOD_1392,         [2] = 35, [3] =  47, [4] = "ALL", [5] = "ALL" },
    [191] = { [1] = CONJ_FOOD_874,          [2] = 25, [3] =  33, [4] = "ALL", [5] = "ALL" },
    [190] = { [1] = CONJ_FOOD_552,          [2] = 15, [3] =  24, [4] = "ALL", [5] = "ALL" },
    [189] = { [1] = CONJ_FOOD_243,          [2] =  5, [3] =  13, [4] = "ALL", [5] = "ALL" },
    [188] = { [1] = CONJ_FOOD_61,           [2] =  0, [3] =   4, [4] = "ALL", [5] = "ALL" },
    [187] = { [1] = COOK_FOOD_75,      		[2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
	[186] = { [1] = DROP_FOOD_15000_2,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [185] = { [1] = DROP_FOOD_15000,        [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [184] = { [1] = COOK_BIS_15000_12960_3, [2] = 70, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [183] = { [1] = COOK_BIS_15000_12960_2, [2] = 70, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [182] = { [1] = COOK_BIS_15000_12960,   [2] = 70, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [181] = { [1] = COOK_FOOD_15000,        [2] = 70, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [180] = { [1] = VEND_FOOD_15000_14,     [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [179] = { [1] = VEND_FOOD_15000_13,     [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [178] = { [1] = VEND_FOOD_15000_12,     [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [177] = { [1] = VEND_FOOD_15000_11,     [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [176] = { [1] = VEND_FOOD_15000_10,     [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [175] = { [1] = VEND_FOOD_15000_9,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [174] = { [1] = VEND_FOOD_15000_8,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [173] = { [1] = VEND_FOOD_15000_7,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [172] = { [1] = VEND_FOOD_15000_6,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [171] = { [1] = VEND_FOOD_15000_5,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [170] = { [1] = VEND_FOOD_15000_4,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [169] = { [1] = VEND_FOOD_15000_3,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [168] = { [1] = VEND_FOOD_15000_2,      [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [167] = { [1] = VEND_FOOD_15000,        [2] = 75, [3] = 500, [4] = "ALL", [5] = "ALL" },
    [166] = { [1] = DROP_FOOD_13200_7,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [165] = { [1] = DROP_FOOD_13200_6,      [2] = 70, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [164] = { [1] = DROP_FOOD_13200_5,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [163] = { [1] = DROP_FOOD_13200_4,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [162] = { [1] = DROP_FOOD_13200_3,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [161] = { [1] = DROP_FOOD_13200_2,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [160] = { [1] = DROP_FOOD_13200,        [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [159] = { [1] = VEND_FOOD_13200_10,     [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [158] = { [1] = VEND_FOOD_13200_9,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [157] = { [1] = VEND_FOOD_13200_8,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [156] = { [1] = VEND_FOOD_13200_7,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [155] = { [1] = VEND_FOOD_13200_6,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [154] = { [1] = VEND_FOOD_13200_5,      [2] = 65, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [153] = { [1] = VEND_FOOD_13200_4,      [2] = 70, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [152] = { [1] = VEND_FOOD_13200_3,      [2] = 70, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [151] = { [1] = VEND_FOOD_13200_2,      [2] = 70, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [150] = { [1] = VEND_FOOD_13200,        [2] = 70, [3] = 440, [4] = "ALL", [5] = "ALL" },
    [149] = { [1] = VEND_BIS_5per20,        [2] = 40, [3] =  SP, [4] = "ALL", [5] = "ALL" },
    [148] = { [1] = COOK_BIS_7500_7200,     [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [147] = { [1] = VEND_BIS_7500_7200,     [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [146] = { [1] = DROP_FOOD_7500,         [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [145] = { [1] = COOK_FOOD_7500,         [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [144] = { [1] = VEND_FOOD_7500_10,      [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [143] = { [1] = VEND_FOOD_7500_9,       [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [142] = { [1] = VEND_FOOD_7500_8,       [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [141] = { [1] = VEND_FOOD_7500_7,       [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [140] = { [1] = VEND_FOOD_7500_6,       [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [139] = { [1] = VEND_FOOD_7500_5,       [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [138] = { [1] = VEND_FOOD_7500_4,       [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [137] = { [1] = VEND_FOOD_7500_3,       [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [136] = { [1] = VEND_FOOD_7500_2,       [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [135] = { [1] = VEND_FOOD_7500,         [2] = 65, [3] = 250, [4] = "ALL", [5] = "ALL" },
    [134] = { [1] = VEND_BIS_4per25_3per25, [2] =  0, [3] =  QP, [4] = "ALL", [5] = "ALL" },
    [133] = { [1] = VEND_BIS_3per25_3,      [2] =  0, [3] =  TP, [4] = "ALL", [5] = "ALL" },
    [132] = { [1] = VEND_BIS_3per25_2,      [2] =  0, [3] =  TP, [4] = "ALL", [5] = "ALL" },
    [131] = { [1] = VEND_BIS_3per25,        [2] =  0, [3] =  TP, [4] = "ALL", [5] = "ALL" },
    [130] = { [1] = CONJ_BIS_4410_4410,     [2] =  0, [3] = 147, [4] = "ALL", [5] = "ALL" },
    [129] = { [1] = VEND_BIS_4410_4410,     [2] = 51, [3] = 147, [4] = "ALL", [5] = "ALL" },
    [128] = { [1] = VEND_BIS_4320_5100,     [2] = 65, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [127] = { [1] = VEND_BIS_4320_4410,     [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [126] = { [1] = DROP_FOOD_4320_8,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [125] = { [1] = DROP_FOOD_4320_7,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [124] = { [1] = DROP_FOOD_4320_6,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [123] = { [1] = DROP_FOOD_4320_5,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [122] = { [1] = DROP_FOOD_4320_4,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [121] = { [1] = DROP_FOOD_4320_3,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [120] = { [1] = DROP_FOOD_4320_2,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [119] = { [1] = DROP_FOOD_4320,         [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [118] = { [1] = COOK_FOOD_4320,         [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [117] = { [1] = VEND_FOOD_4320_7,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [116] = { [1] = VEND_FOOD_4320_6,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [115] = { [1] = VEND_FOOD_4320_5,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [114] = { [1] = VEND_FOOD_4320_4,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [113] = { [1] = VEND_FOOD_4320_3,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [112] = { [1] = VEND_FOOD_4320_2,       [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [111] = { [1] = VEND_FOOD_4320,         [2] = 55, [3] = 144, [4] = "ALL", [5] = "ALL" },
    [110] = { [1] = VEND_BIS_2148_4410,     [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [109] = { [1] = DROP_FOOD_2148_6,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [108] = { [1] = DROP_FOOD_2148_5,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [107] = { [1] = DROP_FOOD_2148_4,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [106] = { [1] = DROP_FOOD_2148_3,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [105] = { [1] = DROP_FOOD_2148_2,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [104] = { [1] = DROP_FOOD_2148,         [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [103] = { [1] = COOK_FOOD_2148_2,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [102] = { [1] = COOK_FOOD_2148,         [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [101] = { [1] = VEND_FOOD_2148_9,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [100] = { [1] = VEND_FOOD_2148_8,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [ 99] = { [1] = VEND_FOOD_2148_7,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [ 98] = { [1] = VEND_FOOD_2148_6,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [ 97] = { [1] = VEND_FOOD_2148_5,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [ 96] = { [1] = VEND_FOOD_2148_4,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [ 95] = { [1] = VEND_FOOD_2148_3,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [ 94] = { [1] = VEND_FOOD_2148_2,       [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [ 93] = { [1] = VEND_FOOD_2148,         [2] = 45, [3] =  72, [4] = "ALL", [5] = "ALL" },
    [ 92] = { [1] = VEND_FOOD_2per25_5,     [2] =  0, [3] =  DP, [4] = "ALL", [5] = "ALL" },
    [ 91] = { [1] = VEND_FOOD_2per25_4,     [2] =  0, [3] =  DP, [4] = "ALL", [5] = "ALL" },
    [ 90] = { [1] = VEND_FOOD_2per25_3,     [2] =  0, [3] =  DP, [4] = "ALL", [5] = "ALL" },
    [ 89] = { [1] = VEND_FOOD_2per25_2,     [2] =  0, [3] =  DP, [4] = "ALL", [5] = "ALL" },
    [ 88] = { [1] = VEND_FOOD_2per25,       [2] =  0, [3] =  DP, [4] = "ALL", [5] = "ALL" },
    [ 87] = { [1] = DROP_FOOD_1392_7,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 86] = { [1] = DROP_FOOD_1392_6,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 85] = { [1] = DROP_FOOD_1392_5,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 84] = { [1] = DROP_FOOD_1392_4,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 83] = { [1] = DROP_FOOD_1392_3,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 82] = { [1] = DROP_FOOD_1392_2,       [2] = 45, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 81] = { [1] = DROP_FOOD_1392,         [2] = 45, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 80] = { [1] = COOK_FOOD_1392_3,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 79] = { [1] = COOK_FOOD_1392_2,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 78] = { [1] = COOK_FOOD_1392,         [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 77] = { [1] = VEND_FOOD_1392_8,       [2] = 25, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 76] = { [1] = VEND_FOOD_1392_7,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 75] = { [1] = VEND_FOOD_1392_6,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 74] = { [1] = VEND_FOOD_1392_5,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 73] = { [1] = VEND_FOOD_1392_4,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 72] = { [1] = VEND_FOOD_1392_3,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 71] = { [1] = VEND_FOOD_1392_2,       [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 70] = { [1] = VEND_FOOD_1392,         [2] = 35, [3] =  46, [4] = "ALL", [5] = "ALL" },
    [ 69] = { [1] = DROP_FOOD_874_6,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 68] = { [1] = DROP_FOOD_874_5,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 67] = { [1] = DROP_FOOD_874_4,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 66] = { [1] = DROP_FOOD_874_3,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 65] = { [1] = DROP_FOOD_874_2,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 64] = { [1] = DROP_FOOD_874,          [2] = 35, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 63] = { [1] = COOK_FOOD_874_2,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 62] = { [1] = COOK_FOOD_874,          [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 61] = { [1] = VEND_FOOD_874_4,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 60] = { [1] = VEND_FOOD_874_3,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 59] = { [1] = VEND_FOOD_874_2,        [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 58] = { [1] = VEND_FOOD_874,          [2] = 25, [3] =  32, [4] = "ALL", [5] = "ALL" },
    [ 57] = { [1] = DROP_FOOD_552_5,        [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 56] = { [1] = DROP_FOOD_552_4,        [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 55] = { [1] = DROP_FOOD_552_3,        [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 54] = { [1] = DROP_FOOD_552_2,        [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 53] = { [1] = DROP_FOOD_552,          [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 52] = { [1] = COOK_FOOD_552_5,        [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 51] = { [1] = COOK_FOOD_552_4,        [2] =  5, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 50] = { [1] = COOK_FOOD_552_3,        [2] = 10, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 49] = { [1] = COOK_FOOD_552_2,        [2] = 10, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 48] = { [1] = COOK_FOOD_552,          [2] = 10, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 47] = { [1] = VEND_FOOD_552_3,        [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 46] = { [1] = VEND_FOOD_552_2,        [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 45] = { [1] = VEND_FOOD_552,          [2] = 15, [3] =  23, [4] = "ALL", [5] = "ALL" },
    [ 44] = { [1] = COOK_BIS_294_294,       [2] =  5, [3] =  14, [4] = "ALL", [5] = "ALL" },
    [ 43] = { [1] = VEND_BIS_294_294,       [2] =  0, [3] =  14, [4] = "ALL", [5] = "ALL" },
    [ 42] = { [1] = DROP_FOOD_243_6,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 41] = { [1] = DROP_FOOD_243_5,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 40] = { [1] = DROP_FOOD_243_4,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 39] = { [1] = DROP_FOOD_243_3,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 38] = { [1] = DROP_FOOD_243_2,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 37] = { [1] = DROP_FOOD_243,          [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 36] = { [1] = COOK_FOOD_243_4,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 35] = { [1] = COOK_FOOD_243_3,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 34] = { [1] = COOK_FOOD_243_2,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 33] = { [1] = COOK_FOOD_243,          [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 32] = { [1] = VEND_FOOD_243_8,        [2] =  0, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 31] = { [1] = VEND_FOOD_243_7,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 30] = { [1] = VEND_FOOD_243_6,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 29] = { [1] = VEND_FOOD_243_5,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 28] = { [1] = VEND_FOOD_243_4,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 27] = { [1] = VEND_FOOD_243_3,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 26] = { [1] = VEND_FOOD_243_2,        [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 25] = { [1] = VEND_FOOD_243,          [2] =  5, [3] =  12, [4] = "ALL", [5] = "ALL" },
    [ 24] = { [1] = DROP_FOOD_61_8,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 23] = { [1] = DROP_FOOD_61_7,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 22] = { [1] = DROP_FOOD_61_6,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 21] = { [1] = DROP_FOOD_61_5,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 20] = { [1] = DROP_FOOD_61_4,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 19] = { [1] = DROP_FOOD_61_3,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 18] = { [1] = DROP_FOOD_61_2,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 17] = { [1] = DROP_FOOD_61,           [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 16] = { [1] = COOK_FOOD_61_4,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 15] = { [1] = COOK_FOOD_61_3,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 14] = { [1] = COOK_FOOD_61_2,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 13] = { [1] = COOK_FOOD_61,           [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 12] = { [1] = VEND_FOOD_61_8,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 11] = { [1] = VEND_FOOD_61_7,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [ 10] = { [1] = VEND_FOOD_61_6,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [  9] = { [1] = VEND_FOOD_61_5,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [  8] = { [1] = VEND_FOOD_61_4,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [  7] = { [1] = VEND_FOOD_61_3,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [  6] = { [1] = VEND_FOOD_61_2,         [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [  5] = { [1] = VEND_FOOD_61,           [2] =  0, [3] =   3, [4] = "ALL", [5] = "ALL" },
    [  4] = { [1] = DROP_BIS_30_60,         [2] =  4, [3] =   2, [4] = "ALL", [5] = "ALL" },
    [  3] = { [1] = DROP_FOOD_30,           [2] =  0, [3] =   2, [4] = "ALL", [5] = "ALL" },
    [  2] = { [1] = VEND_FOOD_30_2,         [2] =  0, [3] =   2, [4] = "ALL", [5] = "ALL" },
    [  1] = { [1] = VEND_FOOD_30,           [2] =  0, [3] =   2, [4] = "ALL", [5] = "ALL" },
  }
end

function GMHealth_Go()
  
  local HealthPotionRank = 0;
  local BHealthPotionRank = 0;
  local HealthPotionItemNum = 0;
  local BHealthPotionItemNum = 0;
  local oldHPotionItemLink = "Nothing";
  local BoldHPotionItemLink = "Nothing";
  local HealthFoodRank = 0;
  local BHealthFoodRank = 0;
  local HealthFoodItemNum = 0;
  local BHealthFoodItemNum = 0;
  local oldFoodItemLink = "Nothing";
  local BoldFoodItemLink = "Nothing";
  
  local Poverride = false
  local Woverride = false
  
  GMHealth_GetZoneType();

  for bagID = 0, 4, 1 do
    local bagSlotCnt = GetContainerNumSlots(bagID);
    if (bagSlotCnt > 0) then
      for slot = 1, bagSlotCnt, 1 do
        local itemLink = GetContainerItemLink(bagID, slot);
        local itemNumber = GMHealth_NumFromLink(itemLink);
        if (itemNumber) then
          for index = 1, table.getn(GMHealth_Potions), 1 do
            if (GMHealth_Potions[index][1] == itemNumber) then
              if (GMHealth_Potions[index][2] <= UnitLevel("player")) then
                if ((GMHealth_Potions[index][4] == GMHealth_ZoneType) or (GMHealth_Potions[index][4] == GMHealth_ZoneName) or (GMHealth_Potions[index][4] == "ALL")) then  
                  if (GMHealth_Potions[index][4] ~= "ALL") then
                    Poverride = true
                    BoldHPotionItemLink = oldHPotionItemLink;
                    oldHPotionItemLink = itemLink;
                    BHealthPotionRank = HealthPotionRank;
                    HealthPotionRank = GMHealth_Potions[index][3];
                    BHealthPotionItemNum = HealthPotionItemNum;
                    HealthPotionItemNum = itemNumber;
                  end
                  if ((GMHealth_Potions[index][3] > HealthPotionRank) and (not Poverride)) then
                    BoldHPotionItemLink = oldHPotionItemLink;
                    oldHPotionItemLink = itemLink;
                    BHealthPotionRank = HealthPotionRank;
                    HealthPotionRank = GMHealth_Potions[index][3];
                    BHealthPotionItemNum = HealthPotionItemNum;
                    HealthPotionItemNum = itemNumber;
                  elseif ((GMHealth_Potions[index][3] == HealthPotionRank) and (itemLink ~= oldHPotionItemLink) and (not Poverride)) then
                    local oldItemCnt = GetItemCount(oldHPotionItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      oldHPotionItemLink = itemLink;
                      HealthPotionRank = GMHealth_Potions[index][3];
                      HealthPotionItemNum = itemNumber;
                    end
                  elseif ((GMHealth_Potions[index][3] < HealthPotionRank) and (GMHealth_Potions[index][3] > BHealthPotionRank)) then
                    BoldHPotionItemLink = itemLink;
                    BHealthPotionRank = GMHealth_Potions[index][3];
                    BHealthPotionItemNum = itemNumber;
                  elseif ((GMHealth_Potions[index][3] == BHealthPotionRank) and (itemLink ~= BoldHPotionItemLink)) then
                    local oldItemCnt = GetItemCount(BoldHPotionItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      BoldHPotionItemLink = itemLink;
                      BHealthPotionRank = GMHealth_Potions[index][3];
                      BHealthPotionItemNum = itemNumber;
                    end
                  end
                end
              end  
            end
          end
          for index = 1, table.getn(GMHealth_Food), 1 do
            if (GMHealth_Food[index][1] == itemNumber) then
              if (GMHealth_Food[index][2] <= UnitLevel("player")) then
                if ((GMHealth_Food[index][4] == GMHealth_ZoneType) or (GMHealth_Food[index][4] == GMHealth_ZoneName) or (GMHealth_Food[index][4] == "ALL")) then  
                  if (GMHealth_Food[index][4] ~= "ALL") then
                    Woverride = true
                    BoldFoodItemLink = oldFoodItemLink;
                    oldFoodItemLink = itemLink;
                    BHealthFoodRank = HealthFoodRank;
                    HealthFoodRank = GMHealth_Food[index][3];
                    BHealthFoodItemNum = HealthFoodItemNum;
                    HealthFoodItemNum = itemNumber;
                  end
                  if ((GMHealth_Food[index][3] > HealthFoodRank) and (not Woverride)) then
                    BoldFoodItemLink = oldFoodItemLink;
                    oldFoodItemLink = itemLink;
                    BHealthFoodRank = HealthFoodRank;
                    HealthFoodRank = GMHealth_Food[index][3];
                    BHealthFoodItemNum = HealthFoodItemNum;
                    HealthFoodItemNum = itemNumber;
                  elseif ((GMHealth_Food[index][3] == HealthFoodRank) and (itemLink ~= oldFoodItemLink) and (not Woverride)) then
                    local oldItemCnt = GetItemCount(oldFoodItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      oldFoodItemLink = itemLink;
                      HealthFoodRank = GMHealth_Food[index][3];
                      HealthFoodItemNum = itemNumber;
                    end
                  elseif ((GMHealth_Food[index][3] < HealthFoodRank) and (GMHealth_Food[index][3] > BHealthFoodRank)) then
                    BoldFoodItemLink = itemLink;
                    BHealthFoodRank = GMHealth_Food[index][3];
                    BHealthFoodItemNum = itemNumber;
                  elseif ((GMHealth_Food[index][3] == BHealthFoodRank) and (itemLink ~= BoldFoodItemLink)) then
                    local oldItemCnt = GetItemCount(BoldFoodItemLink);
                    local newItemCnt = GetItemCount(itemLink);
                    if (newItemCnt <= oldItemCnt) then
                      BoldFoodItemLink = itemLink;
                      BHealthFoodRank = GMHealth_Food[index][3];
                      BHealthFoodItemNum = itemNumber;
                    end
                  end
                end
              end
            end
          end
        end
      end
    end
  end
  
  if ((HealthPotionRank > 0) and (HealthFoodRank > 0) and (BHealthPotionRank > 0) and (BHealthFoodRank > 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, 1, "#showtooltip\n/use "..CONJFOOD..""..COOKIN.." [mod:shift, combat] item:"..BHealthPotionItemNum.."; [combat] item:"..HealthPotionItemNum.."; [mod:alt,mod:shift] item:"..BHealthPotionItemNum.."; [mod:alt] item:"..HealthPotionItemNum.."; [mod:shift] item:"..BHealthFoodItemNum.."; [] item:"..HealthFoodItemNum, nil, nil);
  elseif ((HealthPotionRank > 0) and (HealthFoodRank > 0) and (BHealthPotionRank > 0) and (BHealthFoodRank == 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, 1, "#showtooltip\n/use "..CONJFOOD..""..COOKIN.." [mod:shift, combat] item:"..BHealthPotionItemNum.."; [combat] item:"..HealthPotionItemNum.."; [mod:alt,mod:shift] item:"..BHealthPotionItemNum.."; [mod:alt] item:"..HealthPotionItemNum.."; [] item:"..HealthFoodItemNum, nil, nil);
  elseif ((HealthPotionRank > 0) and (HealthFoodRank > 0) and (BHealthPotionRank == 0) and (BHealthFoodRank > 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, 1, "#showtooltip\n/use "..CONJFOOD..""..COOKIN.." [combat] item:"..HealthPotionItemNum.."; [mod:alt] item:"..HealthPotionItemNum.."; [mod:shift] item:"..BHealthFoodItemNum.."; [] item:"..HealthFoodItemNum, nil, nil);
  elseif ((HealthPotionRank > 0) and (HealthFoodRank == 0) and (BHealthPotionRank > 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, 1, "#showtooltip "..COOKIN.." [mod:shift] item:"..BHealthPotionItemNum.."; item:"..HealthPotionItemNum.."\n/use "..CONJFOOD..""..COOKIN.." [mod:shift, combat] item:"..BHealthPotionItemNum.."; [combat] item:"..HealthPotionItemNum.."; [mod:alt, mod:shift] item:"..BHealthPotionItemNum.."; [mod:alt] item:"..HealthPotionItemNum, nil, nil);
  elseif ((HealthPotionRank == 0) and (HealthFoodRank > 0) and (BHealthFoodRank > 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, 1, "#showtooltip\n/use "..CONJFOOD..""..COOKIN.." [mod:shift] item:"..BHealthFoodItemNum.."; [] item:"..HealthFoodItemNum, nil, nil);
  elseif ((HealthPotionRank > 0) and (HealthFoodRank > 0) and (BHealthPotionRank == 0) and (BHealthFoodRank == 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, 1, "#showtooltip\n/use "..CONJFOOD..""..COOKIN.." [combat] item:"..HealthPotionItemNum.."; [mod:alt] item:"..HealthPotionItemNum.."; [] item:"..HealthFoodItemNum, nil, nil);
  elseif ((HealthPotionRank > 0) and (HealthFoodRank == 0) and (BHealthPotionRank == 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, 1, "#showtooltip "..COOKIN.." item:"..HealthPotionItemNum.."\n/use "..CONJFOOD..""..COOKIN.." [combat] item:"..HealthPotionItemNum.."; [mod:alt] item:"..HealthPotionItemNum, nil, nil);
  elseif ((HealthPotionRank == 0) and (HealthFoodRank > 0) and (BHealthFoodRank == 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, 1, "#showtooltip\n/use "..CONJFOOD..""..COOKIN.." item:"..HealthFoodItemNum, nil, nil);
  elseif ((HealthPotionRank == 0) and (HealthFoodRank == 0)) then
    EditMacro(GMHealth_MACRONAME, GMHealth_MACRONAME, NoCOOKIN, "#showtooltip\n/use "..CONJFOOD..""..COOKIN2, nil, nil);
  end
end

function GMHealth_NumFromLink(itemLink)
  if (not itemLink) then
    return nil;
  end
  local _, _, itemNumber = strfind(itemLink, "item:(%d+):");
  return itemNumber;
end
